# coding: utf-8

"""
    teralytic

    The Teralytic API allows clients to manage their organization, view their fields and and probes, and query sensor readings and analytics.  For sandbox testing you may use the api key: `swagger.teralytic.io`   # noqa: E501

    OpenAPI spec version: 1.0.6
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from teralytic.models.reading_type import ReadingType  # noqa: F401,E501


class DepthReading(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'type': 'ReadingType',
        'depth': 'int',
        'depth_units': 'str'
    }

    attribute_map = {
        'type': 'type',
        'depth': 'depth',
        'depth_units': 'depth_units'
    }

    discriminator_value_class_map = {
        'MicroClimateData': 'MicroClimateData',
        'SensorData': 'SensorData',
        'WeatherData': 'WeatherData'
    }

    def __init__(self, type=None, depth=None, depth_units=None):  # noqa: E501
        """DepthReading - a model defined in Swagger"""  # noqa: E501

        self._type = None
        self._depth = None
        self._depth_units = None
        self.discriminator = 'type'

        if type is not None:
            self.type = type
        if depth is not None:
            self.depth = depth
        if depth_units is not None:
            self.depth_units = depth_units

    @property
    def type(self):
        """Gets the type of this DepthReading.  # noqa: E501


        :return: The type of this DepthReading.  # noqa: E501
        :rtype: ReadingType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this DepthReading.


        :param type: The type of this DepthReading.  # noqa: E501
        :type: ReadingType
        """

        self._type = type

    @property
    def depth(self):
        """Gets the depth of this DepthReading.  # noqa: E501

        The depth value  # noqa: E501

        :return: The depth of this DepthReading.  # noqa: E501
        :rtype: int
        """
        return self._depth

    @depth.setter
    def depth(self, depth):
        """Sets the depth of this DepthReading.

        The depth value  # noqa: E501

        :param depth: The depth of this DepthReading.  # noqa: E501
        :type: int
        """

        self._depth = depth

    @property
    def depth_units(self):
        """Gets the depth_units of this DepthReading.  # noqa: E501

        The depth units (i.e. in, cm)  # noqa: E501

        :return: The depth_units of this DepthReading.  # noqa: E501
        :rtype: str
        """
        return self._depth_units

    @depth_units.setter
    def depth_units(self, depth_units):
        """Sets the depth_units of this DepthReading.

        The depth units (i.e. in, cm)  # noqa: E501

        :param depth_units: The depth_units of this DepthReading.  # noqa: E501
        :type: str
        """

        self._depth_units = depth_units

    def get_real_child_model(self, data):
        """Returns the real base class specified by the discriminator"""
        discriminator_value = data[self.discriminator].lower()
        return self.discriminator_value_class_map.get(discriminator_value)

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DepthReading):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
